

/** simple daemonized threaded application (with shared library call) */

#include <pthread.h>
#include <stdio.h>
#include <unistd.h>
#include <getopt.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "foolib.h"

struct thread_arg
{
  int num;
  int lib;
};

typedef struct thread_arg thread_arg_t; 

void* thread_foo(void* i_arg)
{
  thread_arg_t* l_arg_ptr = (thread_arg_t*)i_arg;
  while(1)
  {
    printf("Hi, I'm thread%d\n", l_arg_ptr->num);
    if( l_arg_ptr->lib)
      foolib_entry(l_arg_ptr->num);
    sleep(2);
  }
}

int main(int argc, char* argv[])
{
  pthread_t l_tid;
  int i = 0;
  int l_daemonize = 0;
  int l_sharedlib = 0; 
  int l_opt = 0;
  thread_arg_t* l_arg_ptr = NULL;
  const struct option l_longOpts[]    =
  {
    {"daemon", 0, 0, 'd'},
    {"shared", 0, 0,'s'},
    {0, 0, 0, 0}
  }; 

  while((l_opt = getopt_long(argc, argv, "sd", l_longOpts, NULL)) != -1)
  {
    switch(l_opt)
    {
      case 's':
	l_sharedlib = 1;
	break;
      case 'd':
	l_daemonize = 1;
	break;
    }
  }
  
  /** Daemonize */
  if( l_daemonize )
  {
    int pid = fork();
    if( pid < 0 )
    {
      perror("Couldn't fork");
      exit(1);
    }
    if( pid != 0 )
    {
      exit(0);
    }

    setsid();
    umask(0);
    chdir("/");
  }

  /** Call shared library routine */
  if( l_sharedlib )
  {
    foolib_entry(4);
  }
  
  /** Create three threads. */
  for(; i < 3; i++)
  {
    if((l_arg_ptr = malloc(sizeof(thread_arg_t))) == NULL)
    {
      perror("couldn't allocate memory\n");
      exit(1);
    }
    
    l_arg_ptr->num = i;
    l_arg_ptr->lib = l_sharedlib;
    pthread_create( &l_tid, NULL, thread_foo, (void*)l_arg_ptr);
  }

  while( 1 )
    sleep(10);

  return 0;
}
